!+
!KWIC parx.h
!
!Id$
!
!History:
!   93-Nov-08[T. Gaetz]
!      . moved from individual source files to included file.
!      . reordered:  double precision, real, integer.
!      . add save statement
!
!  DEFINITIONS (extracted from source files):
!
!    GFOC  : R*8 - GEOMETRIC FOCUS OF SYSTEM WRT STD
!    NDIM  : I*4 - NUMBER OF SURFACES ALLOWED FOR
!    NS    : I*4 - NUMBER OF SURFACES IN SYSTEM
!    KURF  : I*4 - CURRENT SURFACE NUMBER (-1)
!    MING  : I*4 - NUMBER OF RINGS IN FIRST SPOKE
!    M2    : I*4 - NUMBER OF SPOKES
!    RZER  : R*8 - INITIAL NON-ZERO RADIUS OF ANNULAR APERTURE
!    DR    : R*8 - DELTA (R**2) BETWEEN RINGS
!    H2    : R*8 - NOT NEEDED, DUMMIED TO -1. IN NEW VERSION
!-
      INTEGER * 4                          NDIM, NS, KURF, MING, M2
      DOUBLE PRECISION GFOC, RZER, DR, H2
      COMMON /PARX/    GFOC, RZER, DR, H2, NDIM, NS, KURF, MING, M2
      SAVE   /PARX/
